<?php

/*
 * ユニットが持つテーブルの生成を行う
  * @param tbl_unitのマスタ情報
 */
function extunit_install($param, $db) {
    switch(DBTYPE) {
        case "pgsql":
            $sql[] = "CREATE TABLE `extunit_map` (
              `pageu_code` integer NOT NULL DEFAULT '0',
              `bmap_service` smallint NOT NULL DEFAULT '0',
              `bmap_apikey` text,
              `bmap_gapikey` text,
              `bmap_img` text,
              `bmap_title` text NOT     NULL,
              `bmap_addr` text NOT NULL,
              `bmap_body` text,
              `bmap_lat` text NOT NULL,
              `bmap_lng` text NOT NULL,
              `bmap_height` integer NOT NULL,
              `bmap_height_sp` integer DEFAULT NULL,
              `use_sp_flg` smallint DEFAULT '1',
              `use_pc_flg` smallint DEFAULT '1',
              `bg_color` smallint DEFAULT '0',
              `bdr_type` smallint DEFAULT '0',
              `btm_padding` smallint DEFAULT '2',
              `bg_color_sp` smallint DEFAULT '0',
              `bdr_type_sp` smallint DEFAULT '0',
              `btm_padding_sp` smallint DEFAULT '2'
            )";
            $sql[] = "CREATE TABLE `extunit_map_tmp` (
              `pageu_code` integer NOT NULL DEFAULT '0',
              `bmap_service` smallint NOT NULL DEFAULT '0',
              `bmap_apikey` text,
              `bmap_gapikey` text,
              `bmap_img` text,
              `bmap_title` text NOT NULL,
              `bmap_addr` text NOT NULL,
              `bmap_body` text,
              `bmap_lat` text NOT NULL,
              `bmap_lng` text NOT NULL,
              `bmap_height` integer NOT NULL,
              `bmap_height_sp` integer DEFAULT NULL,
              `use_sp_flg` smallint DEFAULT '1',
              `use_pc_flg` smallint DEFAULT '1',
              `bg_color` smallint DEFAULT '0',
              `bdr_type` smallint DEFAULT '0',
              `btm_padding` smallint DEFAULT '2',
              `bg_color_sp` smallint DEFAULT '0',
              `bdr_type_sp` smallint DEFAULT '0',
              `btm_padding_sp` smallint DEFAULT '2'
            )";
            break;
        case "mysql":
            $sql[] = "CREATE TABLE `extunit_map` (
              `pageu_code` integer NOT NULL DEFAULT '0',
              `bmap_service` smallint NOT NULL DEFAULT '0',
              `bmap_apikey` text,
              `bmap_gapikey` text,
              `bmap_img` text,
              `bmap_title` text NOT NULL,
              `bmap_addr` text NOT NULL,
              `bmap_body` text,
              `bmap_lat` text NOT NULL,
              `bmap_lng` text NOT NULL,
              `bmap_height` integer NOT NULL,
              `bmap_height_sp` integer DEFAULT NULL,
              `use_sp_flg` smallint DEFAULT '1',
              `use_pc_flg` smallint DEFAULT '1',
              `bg_color` smallint DEFAULT '0',
              `bdr_type` smallint DEFAULT '0',
              `btm_padding` smallint DEFAULT '2',
              `bg_color_sp` smallint DEFAULT '0',
              `bdr_type_sp` smallint DEFAULT '0',
              `btm_padding_sp` smallint DEFAULT '2'
            )TYPE=InnoDB DEFAULT CHARSET=utf8;";
            $sql[] = "CREATE TABLE `extunit_map_tmp` (
              `pageu_code` integer NOT NULL DEFAULT '0',
              `bmap_service` smallint NOT NULL DEFAULT '0',
              `bmap_apikey` text,
              `bmap_gapikey` text,
              `bmap_img` text,
              `bmap_title` text NOT NULL,
              `bmap_addr` text NOT NULL,
              `bmap_body` text,
              `bmap_lat` text NOT NULL,
              `bmap_lng` text NOT NULL,
              `bmap_height` integer NOT NULL,
              `bmap_height_sp` integer DEFAULT NULL,
              `use_sp_flg` smallint DEFAULT '1',
              `use_pc_flg` smallint DEFAULT '1',
              `bg_color` smallint DEFAULT '0',
              `bdr_type` smallint DEFAULT '0',
              `btm_padding` smallint DEFAULT '2',
              `bg_color_sp` smallint DEFAULT '0',
              `bdr_type_sp` smallint DEFAULT '0',
              `btm_padding_sp` smallint DEFAULT '2'
            )TYPE=InnoDB DEFAULT CHARSET=utf8;";
            //mysql 5.5対応
            if(isset($db->dbversion) && version_compare($db->dbversion,"5.0.0", ">=")){
            //mysql5.0以上の時はTYPEをENGINEに置換え
                foreach((array)$sql as $k => $v){
                    $sql[$k] = str_replace('TYPE=InnoDB','ENGINE = InnoDB', $v);
                }
            }
            break;
        default:
            return false;
            break;
    }
    //sqlの実行
    if(!is_array($sql)||!count($sql)>0) {
        //テーブルのないモジュール、ユニットは存在させない
        return false;
    }
    foreach($sql as $key => $val) {
        if(!$db->query($val)) {
            return false;
        }
    }

    return true;
}
?>
